#Include This Once

Sub WriteError( s As String )
	' Report an error
	MyPrint ""
	MyPrint "Error: " + s + "."
End Sub
Sub CriticalError( s As String )
	' Report error and halt
	Call WriteError( s )
	End -1
End Sub
Sub DuplicateError( n As String )
	' Report a duplicate identifier
	Call CriticalError( "Duplicate identifier " + n )
End Sub
Sub ExpectedError( s As String )
	' Report what was expected
	Call CriticalError( s + " expected" )
End Sub
Sub UndefinedError( n As String )
	' Report an undefined identifier
	Call CriticalError( "Undefined identifier " + n )
End Sub
Sub InvalidOperator( n As String )
	' Report an undefined identifier
	Call CriticalError( "Invalid operator " + n )
End Sub
