#Include This Once

Sub NewFileOutput( obj As iOutput, fileName As String )
	Local buf As iFileOutput
	obj = Class "cFileOutput"
	If Not IsInterface( obj, iOutput ) Then
		MyPrint "Failed to create iOutput for " + fileName
		End
	End If

	buf = obj
	If Not IsInterface( obj, iFileOutput ) Then
		MyPrint "Failed to create iFileOutput for "+fileName
		End
	End If
	If IsInterface( buf, iFileOutput ) Then
		buf.Open( filename )
	Else
		MyPrint "Creating file " + fileName + " failed."
		End
	End If
End Sub

Sub FileOutputClose( obj As iOutput )
	Local buf As iFileOutput
	buf = obj
	If IsObject( buf ) Then
		buf.Close()
	End If
End Sub

Class cFileOutput
	Instance filename_ As String
	Instance fh_ As Long

	Interface iOutput
		Inherit IUnknown

		Method Write( s As String )
			Print #fh_, s;
		End Method

		Method WriteLine( s As String )
			Print #fh_, s
		End Method
	End Interface

	Interface iFileOutput
		Inherit IUnknown

		Method Open( filename As String )
			filename_ = filename
			If fh_ Then Me.Close()
			fh_ = FreeFile
			Open filename_ For Output As #fh_
		End Method

		Method Close()
			If FileAttr( #fh_, 0 ) Then Close #fh_
			fh_ = 0
		End Method
	End Interface
End Class
